# -*- coding: utf-8 -*-
from setuphelpers import *
import time

uninstallkey = []

# Defining variables
bin_name = 'BeCyIGrab230Eng.exe'
app_uninstallkey = 'BeCyIconGrabber'
app_dir = makepath(programfiles32,'BeCyIconGrabber')
app_path = makepath(app_dir,'BeCyIconGrabber.exe')
app_uninstall_path = makepath(app_dir,'UnInstall.exe')


def install():
    # Initializing variables
    package_version = control.version.split('-')[0]
    app_kill = control.impacted_process

    def get_app_version(key):
        return get_file_properties(app_path)['ProductVersion']

    # Installing the package
    install_exe_if_needed(bin_name
        ,key=app_uninstallkey
        ,get_version=get_app_version)
    #killalltasks(app_kill)

    # Avoiding the usage by WAPT of the app built-in Uninstallstring
    uninstallkey.remove(app_uninstallkey)


def uninstall():
    # Initializing variables
    app_name = control.name
    app_kill = control.impacted_process
    count = 0

    # Uninstalling the package
    killalltasks(app_kill)
    run(app_uninstall_path,accept_returncodes=[0,1,3010])

    while installed_softwares(uninstallkey=app_uninstallkey):
        if count == 600:
            error('Unable to uninstall: %s' % app_name)
        time.sleep(1)

    # Removing remaining dir
    if isdir(app_dir):
        remove_tree(app_dir)


def update_package():
    # Initializing variables
    version = control.version.split('-')[0]
    url_dl = 'http://www.becyhome.de/download/BeCyIGrab230Eng.zip' # Not used

    # Changing version of the package
    control.version = '%s-%s'%(version,int(control.version.split('-')[-1])+1)
    control.save_control_to_wapt()
    print('Changing version to: %s in WAPT\\control' % control.version)



